%% Intro to Matlob Topics to cover

% First things first...
% Your directory structure for this class
% Submitting the m files to D2L when done today

%% Interacting with Matlab
% The Matlab Environment
% make a couple of variables A, B, A*B, FirstVar, SecondVar
% sequences 1:5, 1:1:13 5:-1:0
% calendar; calendar(y,m);
% clc
% ctl-c
% date
% now
% datestr
% doc
% edit
% exit
% help
% ver
% dir or ls
% up arrow
% tab
% whos
% suppressing output ;
% comments and cells
% ...
% F5 and F9
% Ctl-R (make it a comment -- Remark)
% Ctl-t (uncomment -- Take it off)
% disp



%% Matrices, Vectors, Cells Arrays
% creating matrices [] rows by cols [row; row; row] your boat
% creating cell array
% structures
% strings
% check if something is a scalar, vector, matrix, string, char
% locating your stuff in the matrix (sequential versus row, col)
% rows by cols (by more) -- e.g., EEG.data
% column-major language (speed, indexing)
% end
% length
% size
% transpose
% linspace (start, stop, num)
% logspace (start, stop, num) where start and stop are 10^x
% define empty matrix
% concatenating matrices (row over row, or col after col) -- two methods [] vs horzcat and vertcat
% ones
% zeros
% nan
% rand randn
% repmat 
% Subtract mean using repmat (or bsxfun; but with 2016b or later, neither needed! Expansion automatically)


%% tidying up
% clear varname
% clear all (no undo!  clear without parameter is same as clear all!)
% close all % closes figure windows
% clc  % clears the command console
% add favorite to toolbar


 
%% Practice Exercise!!
% Matrices and Indexing
% make a 4 x 5 matrix of random numbers
% display the 4th row
% display the 3rd column
% display the item in the 3rd column of the 4th row 
%   using (row, col) notation
%   using serial notation
% BONUS: Find the serial index number of all entries greater than 0.5
% Hint: doc find

%% Quick reminders
% Handy things to always keep in mind
% tab
% whos
% suppressing (or not suppressing) output ;
% comments and cells
% F5 and F9
% Ctl-R (make it a comment -- Remark)
% Ctl-t (uncomment -- Take it off)

%% Cells and Indexing
% create a 1 x 4 cell array with a string in the 3rd cell
% index the contents of that cell 
% what's the difference between {} and () indexing?

%% Structures and Indexing
% create a structure named Beatles that has the following fields:
%  name
%  age
%  isdead

% Populate your structure with the following data:
%  name   age    isdead
%  John   40     true
%  Paul   79     false
%  George 58     true
%  Ringo  81     false

%  Now using indexing, find all the living Beatles
%  Now find the mean age of death of the dead Beatles

% Structures can be converted to tables
% struct2table

%% Other conversions (may or may not work depending on contents)
% str2num
% num2str
% cell2mat
% mat2cell 
% num2cell 
% cell 
% cell2table
% cell2struct
% struct2cell 
% table2cell 

%% Exercise 1
edit Exercise1.m


%% Basic calculations
%  + - * / ^
% .* ./ .^
% abs
% exp (e^ )
% log log10
% rem mod same if X and Y have the same sign, differ by Y if X and Y have different signs
% sqrt
% corrcoef
% sum (dimension)
% mean (dimension)
%    Demo of variable name interfering with built-in function
% median (dimension)
% std 
% max 
% min
% find
% nanmean
% nanmedian
% nansum
% round
% fix (towards zero)
% floor (towards - infinity)
% ceil (towards the higher number)
% sort
% 

%% Exercise 2
edit Exercise2.m
edit Exercise2.mlx  % alternative to demonstrate live scripts

%% Indexing and logicals
% ==
% ~=
% > >=
% < <=
% |
% &
% 
%% Exercise 3
edit Exercise3.m

%% Looping
% for
% end
% Make a loop for 5 iterations to display the iteration number
% else
% elseif
% switch
% case
% otherwise
% while
% tic
% toc
% vectorizing (in Excercise 4)
% 
%% Exercise 4
edit Exercise4.m
% see also forloop.m

%% Scripts versus Functions
% scripts just contain code, and can be run from the command line.
% any variables they create are available in the global workspace
clear all;
FunPlot;
% 
% anything that is used in function does not return to the main program,
% unless you pass it back out.  
% Just like in Vegas ...What happens in the function, stays in the
% function...
clear all;
answer = sample_func(99)

% Your goal -- write functions to accomplish tasks, and then write a much
% shorter script that calls functions.  This is helpful for several
% reasons:
%  1) Makes deciphering code much easier
%  2) Makes altering code much easier
%  3) Makes porting code to new projects much easier
%  4) Makes sharing code much easier
%  5) Keeps your workspace free of extraneous variables, which:
%    a) Makes it tidier and easier to keep track of things
%    b) Keeps memory use lower
%    c) Avoids inadvertent conflict of variables with same names



%% Plotting
% figure
% plot  -- plot(y)  or plot(x,y)
% scatter
% hist
% line
% xlabel
% ylabel
% title

%% Download and extract EEGLab from Class Webpage






